/////////////////////////////////////////////////////////////////////////////
//  Copyright (C) 2002 Ultr@VNC Team Members. All Rights Reserved.
//
//
//	This software is open source; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation version 2.
//
//	This General Public License does NOT permit incorporating this software 
//	into proprietary programs.  If you are unable to comply with the GPL, a 
//	commercial license for this software may be purchased from PeerSec Networks
//	at http://www.peersec.com
//	
//	This program is distributed in WITHOUT ANY WARRANTY; without even the 
//	implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
//	See the GNU General Public License for more details.
//	
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//	http://www.gnu.org/copyleft/gpl.html
//
//
/////////////////////////////////////////////////////////////////////////////
#include<windows.h>
#include<iostream.h>
#include<winsock.h>
#include "sslsocket.h"

#define				NO_FLAG_SET		0
#define				MAXBUFLEN		1024
#define				LOG_FILE		"c:\\temp\\tcptunnel.log"

DWORD	ServiceThread(LPDWORD param);
void	install(void);
void	remove(void);


struct ConnectInfo
{
	int				clientPort;
	char			backEndServerIPAddr[100];
	int				serverPort;
};


class SocketPanic
{
public:
	SocketPanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];
};

class ThreadPanic
{
public:
	ThreadPanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];
};

class FilePanic
{
public:
	FilePanic(int level, char *recvmsg)
	{
		GetLocalTime(&st);

		_itoa(st.wYear,buf,10);
		strcpy(msg,buf);
		strcat(msg,"/");
		_itoa(st.wMonth,buf,10);
		strcat(msg,buf);
		strcat(msg,"/");
		_itoa(st.wDay,buf,10);
		strcat(msg,buf);
		strcat(msg," ");
		_itoa(st.wHour,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wMinute,buf,10);
		strcat(msg,buf);
		strcat(msg,":");
		_itoa(st.wSecond,buf,10);
		strcat(msg,buf);
		strcat(msg," ");

		strcat(msg,recvmsg);
	}

	int severity() 
	{
		return level;
	}
	
	char* reason() 
	{

		FILE *f;

		if ((f = fopen(LOG_FILE, "a")) != NULL)
		{
			fprintf(f,msg);
			fclose(f);
		}

		return msg; 
	}

private:
	char	msg[100];
	int		level;
	SYSTEMTIME	st; 
	char	buf[5];	
};

class TCPTunnelServer
{
public:

	TCPTunnelServer(
		int clientPort,
		char* BackEndServerIPAddr,
		int BackEndServerPort);			// Constructor

	void connect();
	void start();
	void close();
	void digTunnel();
	bool connected;
	sslConn_t			*conn;

private:

	SOCKET		listenSocket;
	SOCKET		clientSocket;
	SOCKET		serverSocket;

	int			clientPort;
	char		BackEndServerIPAddr[100];
	int			BackEndServerPort;
	sslSessionId_t		*sessionId;
	sslKeys_t			*keys;
};


class TCPTunnel
{
public:
	TCPTunnel(SOCKET clientSocket, SOCKET serverSocket,sslConn_t *conn,sslSessionId_t		*sessionId,sslKeys_t			*keys);	// Constructor
	void start();
	void returnWay();

private:
	SOCKET		clientSocket;
	SOCKET		serverSocket;
	sslSessionId_t		*sessionId;
	sslConn_t			*conn;
	sslKeys_t			*keys;
	bool		lifeFlag;

};
